<template>
  <Disclosure as="nav" class="bg-gray-800" v-slot="{ open }">
    <div class="mx-auto max-w-7xl px-2 sm:px-6 lg:px-8">
      <div class="relative flex h-16 items-center justify-between">
        <div class="absolute inset-y-0 left-0 flex items-center sm:hidden">
          <!-- Mobile menu button-->
          <DisclosureButton
            class="inline-flex items-center justify-center rounded-md p-2 text-gray-400 hover:bg-gray-700 hover:text-white focus:outline-none focus:ring-2 focus:ring-inset focus:ring-white"
          >
            <span class="sr-only">Open main menu</span>
            <Bars3Icon v-if="!open" class="block h-6 w-6" aria-hidden="true" />
            <XMarkIcon v-else class="block h-6 w-6" aria-hidden="true" />
          </DisclosureButton>
        </div>
        <div class="flex flex-1 items-center justify-center sm:items-stretch sm:justify-start">
          <div class="flex flex-shrink-0 items-center">
            <img class="h-8 w-auto lg:block" src="/src/assets/logo.png" alt="Beer" />
          </div>
          <div class="hidden sm:ml-6 sm:block">
            <div class="flex space-x-4">
              <template v-for="item in navigation" :key="item.name">
                <div v-if="showItem(item)">
                  <RouterLink
                    :to="item.href"
                    :class="[
                      item.current ? 'bg-gray-900 text-white' : 'text-gray-300 hover:bg-gray-700 hover:text-white',
                      'px-3 py-2 rounded-md text-sm font-medium'
                    ]"
                    :aria-current="item.current ? 'page' : undefined"
                    @click="setActive(item)"
                    >{{ item.name }}
                  </RouterLink>
                </div>
              </template>
            </div>
          </div>
        </div>
        <div
          v-if="authStore.isAuthenticated"
          class="absolute inset-y-0 right-0 flex items-center pr-2 sm:static sm:inset-auto sm:ml-6 sm:pr-0"
        >
          <p class="rounded-full p-1 text-white">
            {{ authStore.user.username }}
          </p>

          <!-- Profile dropdown -->
          <Menu as="div" class="relative ml-3">
            <div>
              <MenuButton
                class="flex rounded-full bg-gray-800 text-sm focus:outline-none focus:ring-2 focus:ring-white focus:ring-offset-2 focus:ring-offset-gray-800"
              >
                <img class="h-8 w-8 rounded-full" src="/src/assets/avatar.png" alt="avatar" />
              </MenuButton>
            </div>
            <transition
              enter-active-class="transition ease-out duration-100"
              enter-from-class="transform opacity-0 scale-95"
              enter-to-class="transform opacity-100 scale-100"
              leave-active-class="transition ease-in duration-75"
              leave-from-class="transform opacity-100 scale-100"
              leave-to-class="transform opacity-0 scale-95"
            >
              <MenuItems
                class="absolute right-0 z-10 mt-2 w-48 origin-top-right rounded-md bg-white py-1 shadow-lg ring-1 ring-black ring-opacity-5 focus:outline-none"
              >
                <MenuItem v-slot="{ active }">
                  <p
                    @click="signOut"
                    :class="[active ? 'bg-gray-100' : '', 'block px-4 py-2 text-sm text-gray-700 cursor-pointer']"
                  >
                    Sign out
                  </p>
                </MenuItem>
                <MenuItem v-slot="{ active }">
                  <RouterLink
                    to="/favorites"
                    :class="[active ? 'bg-gray-100' : '', 'block px-4 py-2 text-sm text-gray-700 cursor-pointer']"
                  >
                    Favorite beers
                  </RouterLink>
                </MenuItem>
              </MenuItems>
            </transition>
          </Menu>
        </div>
      </div>
    </div>

    <DisclosurePanel class="sm:hidden">
      <div class="space-y-1 px-2 pt-2 pb-3">
        <template v-for="item in navigation" :key="item.name">
          <div v-if="showItem(item)">
            <RouterLink
              :to="item.href"
              as="a"
              :class="[
                item.current ? 'bg-gray-900 text-white' : 'text-gray-300 hover:bg-gray-700 hover:text-white',
                'block px-3 py-2 rounded-md text-base font-medium'
              ]"
              :aria-current="item.current ? 'page' : undefined"
              @click="setActive(item)"
              >{{ item.name }}</RouterLink
            >
          </div>
        </template>
      </div>
    </DisclosurePanel>
  </Disclosure>
</template>

<script setup lang="ts">
import { Disclosure, DisclosureButton, DisclosurePanel, Menu, MenuButton, MenuItem, MenuItems } from '@headlessui/vue';
import { Bars3Icon, XMarkIcon } from '@heroicons/vue/24/outline';
import { useAuthStore } from '@/stores/auth';
import { useRouter } from 'vue-router';
import { ref } from 'vue';
import { storeToRefs } from 'pinia';

interface NavigationItem {
  name: string;
  href: string;
  current: boolean;
  showWhenAuth: boolean;
}

const router = useRouter();

const authStore = useAuthStore();
const { isAuthenticated } = storeToRefs(authStore);

const navigation = ref([
  { name: 'Beers', href: '/', current: true, showWhenAuth: true },
  { name: 'Sign In', href: '/signIn', current: false, showWhenAuth: false },
  { name: 'Sign Up', href: '/signUp', current: false, showWhenAuth: false }
] as NavigationItem[]);
const signOut = () => {
  authStore.signOut();
  router.push('/signIn');
};

const setActive = (item: NavigationItem) => {
  navigation.value.forEach((nav) => (nav.current = false));
  item.current = true;
};

const showItem = (item: NavigationItem) =>
  item.showWhenAuth || (item.showWhenAuth && isAuthenticated.value) || (!item.showWhenAuth && !isAuthenticated.value);
</script>
